Merge pull request #7210 from nextcloud/pg10

add postgresql 10 compatibility to dbal
This commit is contained in:
Morris Jobke 2017-11-27 16:40:58 +01:00 committed by GitHub
commit 4a63727ed9
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
8 changed files with 42 additions and 121 deletions

View File

@ -299,6 +299,7 @@ pipeline:
matrix:
DB: postgres
PHP: 5.6
POSTGRES: 9
postgres-php7.0:
image: nextcloudci/php7.0:php7.0-16
commands:
@ -746,12 +747,19 @@ matrix:
ENABLE_REDIS: true
- DB: postgres
PHP: 5.6
POSTGRES: 9
ENABLE_REDIS: true
- DB: postgres
PHP: 7.0
POSTGRES: 9
ENABLE_REDIS: true
- DB: postgres
PHP: 7.1
POSTGRES: 9
ENABLE_REDIS: true
- DB: postgres
PHP: 7.1
POSTGRES: 10
ENABLE_REDIS: true
- DB: mysqlmb4
PHP: 5.6
@ -833,7 +841,7 @@ services:
when:
matrix:
ENABLE_REDIS_CLUSTER: true
postgres:
postgres-9:
image: postgres:9
environment:
- POSTGRES_USER=oc_autotest
@ -843,6 +851,18 @@ services:
when:
matrix:
DB: postgres
POSTGRES: 9
postgres-10:
image: postgres:10
environment:
- POSTGRES_USER=oc_autotest
- POSTGRES_PASSWORD=owncloud
tmpfs:
- /var/lib/postgresql/data
when:
matrix:
DB: postgres
POSTGRES: 10
mysql:
image: mysql:5.7
environment:

@ -1 +1 @@
Subproject commit ec71700daf6aab080502f67ecfca274dcb0bb3d9
Subproject commit f4e328bc4cc67011d206ca024483531a3b8c544e

View File

@ -308,11 +308,11 @@ function execute_tests {
echo "Postgres is up."
else
if [ ! -z "$DRONE" ] ; then
DATABASEHOST=postgres
DATABASEHOST="postgres-$POSTGRES"
fi
echo "Waiting for Postgres to be available ..."
if ! apps/files_external/tests/env/wait-for-connection $DATABASEHOST 5432 60; then
echo "[ERROR] Waited 60 seconds, no response" >&2
echo "[ERROR] Waited 60 seconds for $DATABASEHOST, no response" >&2
exit 1
fi
echo "Give it 10 additional seconds ..."

View File

@ -540,7 +540,6 @@ return array(
'OC\\DB\\Migrator' => $baseDir . '/lib/private/DB/Migrator.php',
'OC\\DB\\MySQLMigrator' => $baseDir . '/lib/private/DB/MySQLMigrator.php',
'OC\\DB\\MySqlTools' => $baseDir . '/lib/private/DB/MySqlTools.php',
'OC\\DB\\OCPostgreSqlPlatform' => $baseDir . '/lib/private/DB/OCPostgreSqlPlatform.php',
'OC\\DB\\OCSqlitePlatform' => $baseDir . '/lib/private/DB/OCSqlitePlatform.php',
'OC\\DB\\OracleConnection' => $baseDir . '/lib/private/DB/OracleConnection.php',
'OC\\DB\\OracleMigrator' => $baseDir . '/lib/private/DB/OracleMigrator.php',

View File

@ -570,7 +570,6 @@ class ComposerStaticInit53792487c5a8370acc0b06b1a864ff4c
'OC\\DB\\Migrator' => __DIR__ . '/../../..' . '/lib/private/DB/Migrator.php',
'OC\\DB\\MySQLMigrator' => __DIR__ . '/../../..' . '/lib/private/DB/MySQLMigrator.php',
'OC\\DB\\MySqlTools' => __DIR__ . '/../../..' . '/lib/private/DB/MySqlTools.php',
'OC\\DB\\OCPostgreSqlPlatform' => __DIR__ . '/../../..' . '/lib/private/DB/OCPostgreSqlPlatform.php',
'OC\\DB\\OCSqlitePlatform' => __DIR__ . '/../../..' . '/lib/private/DB/OCSqlitePlatform.php',
'OC\\DB\\OracleConnection' => __DIR__ . '/../../..' . '/lib/private/DB/OracleConnection.php',
'OC\\DB\\OracleMigrator' => __DIR__ . '/../../..' . '/lib/private/DB/OracleMigrator.php',

View File

@ -139,9 +139,6 @@ class ConnectionFactory {
unset($additionalConnectionParams['host']);
break;
case 'pgsql':
$additionalConnectionParams['platform'] = new OCPostgreSqlPlatform();
break;
case 'sqlite3':
$journalMode = $additionalConnectionParams['sqlite.journal_mode'];
$additionalConnectionParams['platform'] = new OCSqlitePlatform();

View File

@ -1,95 +0,0 @@
<?php
/**
* @copyright Copyright (c) 2017, ownCloud GmbH
*
* @author Joas Schilling <coding@schilljs.com>
*
* @license AGPL-3.0
*
* This code is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License, version 3,
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License, version 3,
* along with this program. If not, see <http://www.gnu.org/licenses/>
*
*/
namespace OC\DB;
use Doctrine\DBAL\Platforms\PostgreSqlPlatform;
use Doctrine\DBAL\Schema\ColumnDiff;
use Doctrine\DBAL\Schema\TableDiff;
use Doctrine\DBAL\Types\Type;
class OCPostgreSqlPlatform extends PostgreSqlPlatform {
/**
* {@inheritDoc}
*/
public function getAlterTableSQL(TableDiff $diff){
$queries = parent::getAlterTableSQL($diff);
foreach ($queries as $index => $sql){
// BIGSERIAL could not be used in statements altering column type
// That's why we replace it with BIGINT
// see https://github.com/owncloud/core/pull/28364#issuecomment-315006853
if (preg_match('|(ALTER TABLE\s+\S+\s+ALTER\s+\S+\s+TYPE\s+)(BIGSERIAL)|i', $sql, $matches)) {
$alterTable = $matches[1];
$queries[$index] = $alterTable . 'BIGINT';
}
// Changing integer to bigint kills next autoincrement value
// see https://github.com/owncloud/core/pull/28364#issuecomment-315006853
if (preg_match('|ALTER TABLE\s+(\S+)\s+ALTER\s+(\S+)\s+DROP DEFAULT|i', $sql, $matches)) {
$queryColumnName = $matches[2];
$columnDiff = $this->findColumnDiffByName($diff, $queryColumnName);
if ($columnDiff && $this->shouldSkipDropDefault($columnDiff)) {
unset($queries[$index]);
continue;
}
}
}
return $queries;
}
/**
* We should NOT drop next sequence value if
* - type was changed from INTEGER to BIGINT
* - column keeps an autoincrement
* - default value is kept NULL
*
* @param ColumnDiff $columnDiff
* @return bool
*/
private function shouldSkipDropDefault(ColumnDiff $columnDiff) {
$column = $columnDiff->column;
$fromColumn = $columnDiff->fromColumn;
return $fromColumn->getType()->getName() === Type::INTEGER
&& $column->getType()->getName() === Type::BIGINT
&& $fromColumn->getDefault() === null
&& $column->getDefault() === null
&& $fromColumn->getAutoincrement()
&& $column->getAutoincrement();
}
/**
* @param TableDiff $diff
* @param string $name
* @return ColumnDiff | false
*/
private function findColumnDiffByName(TableDiff $diff, $name) {
foreach ($diff->changedColumns as $columnDiff) {
$oldColumnName = $columnDiff->getOldColumnName()->getQuotedName($this);
if ($oldColumnName === $name) {
return $columnDiff;
}
}
return false;
}
}

View File

@ -18,33 +18,34 @@
* along with this program. If not, see <http://www.gnu.org/licenses/>
*
*/
namespace Test\DB;
use Doctrine\DBAL\Platforms\PostgreSqlPlatform;
use Doctrine\DBAL\Schema\Comparator;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\DBAL\Schema\TableDiff;
use Doctrine\DBAL\Types\Type;
use OC\DB\OCPostgreSqlPlatform;
/**
/**
* Class OCPostgreSqlPlatformTest
*
* custom OCPostgreSqlPlatform behavior has been upstreamed, test is left to
* ensure behavior stays correct.
*
* @group DB
*
* @package Test\DB
*/
class OCPostgreSqlPlatformTest extends \Test\TestCase {
public function testAlterBigint(){
$platform = new OCPostgreSqlPlatform();
public function testAlterBigint() {
$platform = new PostgreSqlPlatform();
$sourceSchema = new Schema();
$targetSchema = new Schema();
$this->createTableAndColumn($sourceSchema, Type::INTEGER);
$this->createTableAndColumn($targetSchema, Type::BIGINT);
$comparator = new Comparator();
$diff = $comparator->compare($sourceSchema, $targetSchema);
$sqlStatements = $diff->toSql($platform);
@ -53,22 +54,22 @@ class OCPostgreSqlPlatformTest extends \Test\TestCase {
$sqlStatements,
true
);
$this->assertNotContains(
'ALTER TABLE poor_yorick ALTER id DROP DEFAULT',
$sqlStatements,
true
);
}
protected function createTableAndColumn($schema, $type){
protected function createTableAndColumn($schema, $type) {
$table = $schema->createTable("poor_yorick");
$table->addColumn('id', $type, [
'autoincrement' => true,
'unsigned' => true,
'notnull' => true,
'length' => 11,
'unsigned' => true,
'notnull' => true,
'length' => 11,
]);
}
}